/*-------------------------------------------------------------------------
 *
 * param_data.hpp
 *
 *         : BSD.
 *         Copyright (c) 2004 Andrei V. Shetuhin
 *
 *             
 *
 *
 *-------------------------------------------------------------------------
 */
// C Includes

// C++ Includes
#include <stdexcept>
#include <string>
#include <vector>
#include <map>

// Local Includes

#ifndef _PARAM_DATA_HPP__
#define _PARAM_DATA_HPP__ 1

namespace template_parser_ns
{

struct param_data;
// 
typedef std::string                         t_param_str;
// 
typedef std::vector<param_data *>           t_param_array;
// 
typedef std::map<std::string, param_data *> t_param_hash;

#define C_TEMPLATE_MAX_TOKEN_LEN 128
//
//  
//
struct param_data
{
	enum e_value_type { VAR, ARRAY, HASH };

	// 
	param_data                 * parent;
	//  
	e_value_type                 type;
	// 
	void                       * value;
	// Undef
	bool                         undef;
	// 
	param_data(e_value_type eIType = VAR);

	//     VAL
	t_param_str   *      val();
	//     ARRAY
	t_param_array *      array();
	//     HASH
	t_param_hash  *      hash();

	void hash_insert_new_var(const std::string &sKey, const std::string &sValue);
	// 
	~param_data();
};
} // namespace template_parser_ns
#endif // _PARAM_DATA_HPP__
// End.
